///////////////////////////////////////////////////////////////////////////////
// Name:        MetaMaxScript.h
// Purpose:     Macroses to build plugins for 3ds max in MAXScript language
//              with the "Wave" precompiler.
// Author:      Vitaly Baranov
// Created:     January 14, 2009
// Modified by:  
// Licence:     GNU General Public License
///////////////////////////////////////////////////////////////////////////////

// Meta language macroses for MAXScript language
#ifndef META_MAXSCRIPT_H
#define META_MAXSCRIPT_H

#include "MetaMaxScript_Var.h"
#include "MetaMaxScript_ControlFlow.h"
#include "MetaMaxScript_Function.h"
#include "MetaMaxScript_Class.h"
#include "MetaMaxScript_Numeric.h"
#include "MetaMaxScript_String.h"
#include "MetaMaxScript_Bit.h"
#include "MetaMaxScript_Exception.h"
#include "MetaMaxScript_NumConv.h"
#include "MetaMaxScript_File.h"
#include "MetaMaxScript_System.h"
#include "MetaMaxScript_Array.h"
#include "MetaMaxScript_ErrBox.h"
#include "MetaMaxScript_Importer.h"
#include "MetaMaxScript_Exporter.h"
#include "MetaMaxScript_StdDirs.h"
#include "MetaMaxScript_Color.h"
#include "MetaMaxScript_Material.h"
#include "MetaMaxScript_Point3.h"
#include "MetaMaxScript_Quat.h"
#include "MetaMaxScript_Matrix3.h"
#include "MetaMaxScript_Object.h"
#include "MetaMaxScript_Mesh.h"
#include "MetaMaxScript_Bone.h"
#include "MetaMaxScript_Skin.h"
#include "MetaMaxScript_Anim.h"
#include "MetaMaxScript_Scene.h"
#include "MetaMaxScript_Unit.h"
#include "MetaMaxScript_Layer.h"
#include "MetaMaxScript_Progress.h"

#endif // META_MAXSCRIPT_H
